;;
;; .., DynDraw\DynDraw.lsp
;;   "AutoCAD:  ,   "
;; ( "-", 2005)
;;
;;--------------------------------------------------------------------
;;                           (DynDraw) 
;;--------------------------------------------------------------------
;;
;;  :
;;  (dyndraw
;;    <call_back>      -  callback- (STR)
;;    <input_prompt>   -   (STR)
;;    <keyword_list>   -    (STR)
;;    <input_flag>     -    (INT)
;;    <cursor_type>    -   (INT)        
;;    <base_point>     -    nil
;;  )
;;
;;     : 
;;
;;  1) <call_back> 
;;       callback-.     
;;       : (vl-acad-defun '<call_back>)
;;     
;;        .    <input_flag>
;;       :
;;     1) (X Y Z)      - ,         acqurePoint
;;     2) REAL         - ,    acqureDist
;;     3) REAL         - ,          acqureAngle
;;     4) STR          -     -       
;;                         -    AcceptOtherInputString
;;
;;           :
;;     1) nil          -   ;
;;     2) (X Y Z)      -  -   ;
;;     3) (list ...)   - ,   
;;                        dyndraw   
;;                       ;
;;     4) STR          -  -    
;;                          
;;     5) T            -     
;;                       ;
;;  2) <input_prompt>
;;       ,     getXXXX
;;
;;  3) <keyword_list>  
;;       ,    initget
;;
;;  4) <input_flag>    
;;       -     
;;        :
;;
;;     GovernedByOrthoMode             1
;;     NullResponseAccepted            2
;;     DontEchoCancelForCtrlC          4
;;     DontUpdateLastPoint             8
;;     NoDwgLimitsChecking            16
;;     NoZeroResponseAccepted         32
;;     NoNegativeResponseAccepted     64
;;     Accept3dCoordinates           128
;;     AcceptMouseUpAsPoint          256
;;     AnyBlankTerminatesInput       512
;;     InitialBlankTerminatesInput  1024
;;     AcceptOtherInputString       2048
;;
;;          :
;;
;;     acqurePoint        0  -     (  callback) 
;;                               point -  
;;     acqureDist      8192  -     (  callback) 
;;                               REAL - 
;;     acqureAngle    16384  -     (  callback) 
;;                               REAL -  ( )
;;
;;  5) <cursor_type>
;;       ( ) -    :
;;     NoSpecialCursor      -1      No special cursor specified 
;;     Crosshair             0      Full screen cross hair 
;;     RectCursor            1      Rectangular cursor 
;;     RubberBand            2      Rubber band line 
;;     NotRotated            3      (AutoCAD internal use only) 
;;     TargetBox             4      Target Box type 
;;     RotatedCrosshair      5      (AutoCAD internal use only) 
;;     CrossHairNoRotate     6      Crosshairs forced non-rotated 
;;     Invisible             7      Invisible cursor 
;;     EntitySelect          8      Entity selection target cursor 
;;     Parallelogram         9      Parallelogram cursor 
;;     EntitySelectNoPersp  10      Pickbox, suppressed in persp 
;;     PkfirstOrGrips       11      Auto-select cursor 
;;
;;  6) <base_point>
;;        nil -     .
;;
;;       :
;;     1) (list X Y Z) - ,         acqurePoint
;;     2) REAL         - ,    acqureDist
;;     3) REAL         - ,          acqureAngle
;;     4) STR          - ,      callback- 
;;                                    
;;     5) nil          -   
;;
;;    :
;; 1) callback-      
;;     ,      
;;     .
;; 2)     ,
;;      ,   callback-  
;;          entupd,
;;     vla-Update.      vla-  
;;    vlax-   callback-.
;; 3)      grdraw  grvecs,
;;       (redraw)   .
;; 4)      
;;         -  
;;     ,    dyndraw  :
;;    (command "_.Redraw")     
;;    (command "_.Undo" "_Begin")  (command "_.Undo" "_End")
;; 5)  callback     ,
;;       dyndraw,       callback-
;;    ,     callback-  
;;      ,    ..
;;--------------------------------------------------------------------

;;--------------------------------------------------------------------
;;            DynDraw
;;--------------------------------------------------------------------
(defun C:DYN_TEST ( / p_prev p_base p min_step 
                      ang dist p1 p2 p3 _bm _ce
                  )
  ;;    (  ),
  ;;      
  (setq min_step 1e-6) 
  ;;  arx-    -  
  ;; ,       
  ;; AutoCAD   
  (if (null dyndraw) (progn
    (arxload "dyndraw.arx")
  )) ;_endof if progn 
  ;;  BLIPMODE -  polar  
  (setq _bm (getvar "blipmode") _ce (getvar "cmdecho")) 
  (setvar "blipmode" 0) (setvar "cmdecho" 0)
  ;;      ObjectARX
  ;;   !!!
  (vl-acad-defun 'dyn_call_back) 

  (setq p (getvar "LASTPOINT"))
  
  (while 
    (and dyndraw p (/= (type p) 'STR)
         (setq p (getpoint "\n   (ENTER - ): ")))
    (setq p_base p p_prev p) 
    (setq p 
      (dyndraw 
         ;;  callback - 
         "dyn_call_back"
         ;;  
         "\n  [ ]: "
         ;;   
         " B _ B B" ;;    ,  
                     ;;    
                     ;;   
         ;;   
         (+ 2 128 2048) ;;     3D-
         ;;    
         2 ;;   
         ;;   ( UCS)
         p
      )
    )
    (redraw)
    (if (= (type p) 'LIST) (progn
      ;;       !
      (setq ang   (angle p_base p)
            dist  (* (distance p_base p) (sqrt 2))
            p1    (polar p (+ ang (* pi 0.75)) dist)
            p2    (polar p1 (+ ang (* pi 1.25)) dist)
            p3    (polar p2 (+ ang (* pi 1.75)) dist)
      )
      (command "_.undo" "_begin")
      (command "_.pline" "_none" p "_w" 0 0 "_none" p1  "_none" p2  "_none" p3 "_c")
      (command "_.undo" "_end")
    )) ;_endof if progn 
  ) ;_endof while  
  (if (= (type p) 'STR)
    (princ (strcat "\n  : <" p ">"))
  ) 

  (setvar "blipmode" _bm) (setvar "cmdecho" _ce)
  (princ)
) ;_endof defun 
;;--------------------------------------------------------------------
;;                callback-
;; 1.     ,    
;;      UCS,   .    
;;      "_",     
;; 2.  nil     ,  
;;     ,      nil
;; 3.     ,    
;;     ,    .
;; 4.     ,   
;;       dyndraw,   
;;      .        
;;    callback-,
;;--------------------------------------------------------------------
(defun dyn_call_back (p / p1 p2 p3)
 (cond
  ((= (type p) 'STR) ;;   
    (redraw) ;;    
    (cond 
     ((= p "B") ;;   
      (if (setq p (getpoint p_base "\n   : "))
        (setq p_base p
              p  (list 
                  "dyn_call_back" 
                  "\n  : "
                  "" ;;   
                  (+ 2 128 2048) ;;     3D-
                  2 ;  
                  p
                 )
         )
      ) 
     )
     (T
      ;;   
      (princ (strcat "\n   <" p ">!!!"))
     )
    ) ;_endof cond 
  )
  ((= (type p) 'LIST) ;;   
    (if (null p_base) (setq p_base p p_prev p)) 
    (if (and p_prev (> (distance p_prev p) min_step)) (progn
      (setq p_prev p) 
      (setq input p
            ang   (angle p_base p)
            dist  (* (distance p_base input) (sqrt 2))
            p1    (polar input (+ ang (* pi 0.75)) dist)
            p2    (polar p1 (+ ang (* pi 1.25)) dist)
            p3    (polar p2 (+ ang (* pi 1.75)) dist)
       )
       (redraw) ;;    
       (grdraw input p1 -1)
       (grdraw p1 p2 -1)
       (grdraw p2 p3 -1)
       (grdraw p3 input -1)
    ))
  )
 ) ;_endof cond 
 p
) ;_endof defun
